package com.hikcreate.Utils

import java.text.SimpleDateFormat
import java.util.{Calendar, Date}
class DateUtils(datetime: String){
  val date: Date =toDate()
  private val calendar: Calendar = getCalendar()

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val YEAR: Int = if(calendar == null) -1 else calendar.get(Calendar.YEAR)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val MONTH: Int = if(calendar == null) -1 else calendar.get(Calendar.MONTH) + 1

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val QUARTER: Int = if(calendar == null) -1 else getQuarter()

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val WEEK_OF_YEAR: Int = if(calendar == null) -1 else calendar.get(Calendar.WEEK_OF_YEAR)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val WEEK_OF_MONTH: Int = if(calendar == null) -1 else calendar.get(Calendar.WEEK_OF_MONTH)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val DAY_OF_YEAR: Int = if(calendar == null) -1 else calendar.get(Calendar.DAY_OF_YEAR)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val DAY_OF_MONTH: Int = if(calendar == null) -1 else calendar.get(Calendar.DAY_OF_MONTH)

  /**
    * 若datetime为"null"，则值为-1，如果day_of_week为1，则值为7，否则为day_of_week-1
    */
  val DAY_OF_WEEK: Int = if(calendar == null) -1 else if(calendar.get(Calendar.DAY_OF_WEEK) == 1) 7 else calendar.get(Calendar.DAY_OF_WEEK) -1

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val HOUR_OF_DAY: Int = if(calendar == null) -1 else calendar.get(Calendar.HOUR_OF_DAY)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val MINUTE: Int = if(calendar == null) -1 else calendar.get(Calendar.MINUTE)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val SECOND: Int = if(calendar == null) -1 else calendar.get(Calendar.SECOND)

  /**
    * 若datetime为"null"，则值为-1，否则为其正常值
    */
  val MILLISECOND: Int = if(calendar == null) -1 else calendar.get(Calendar.MILLISECOND)

  /**
    * 若datetime为"null"，则值为null，否则为其正常值
    */
  val FIRST_DAY_OF_MONTH: String = if(calendar == null) null else s"""$YEAR-${if(MONTH < 10) "0" + MONTH else MONTH}-01"""

  /**
    * 若datetime为"null"，则值为null，否则为其正常值
    */
  val FIRST_DAY_OF_YEAR: String = if(calendar == null) null else s"""$YEAR-01-01"""
  def toString(format: String): String = {
    if(date == null){
      null
    } else {
      val quarter = "0" + QUARTER
      val month = if(MONTH < 10) s"""0$MONTH""" else MONTH
      val dayOfMonth = if(DAY_OF_MONTH < 10) s"""0$DAY_OF_MONTH""" else DAY_OF_MONTH
      val hourOfDay = if(HOUR_OF_DAY < 10) s"""0$HOUR_OF_DAY""" else HOUR_OF_DAY
      val minute = if(MINUTE < 10) s"""0$MINUTE""" else MINUTE
      val second = if(SECOND < 10) s"""0$SECOND""" else SECOND
      val weekOfYear = if(WEEK_OF_YEAR < 10) s"""0$WEEK_OF_YEAR""" else WEEK_OF_YEAR
      val weekOfMonth = if(WEEK_OF_MONTH < 10) s"""0$WEEK_OF_MONTH""" else WEEK_OF_MONTH
      val formatList = List(
        "yyyy",
        "QQ",
        "MM",
        "M",
        "dd",
        "d",
        "HH",
        "mm",
        "ss",
        "yyyyMM",
        "yyyy/MM",
        "yyyy-MM",
        "yyyy年MM月",
        "yyyyMMdd",
        "yyyy/MM/dd",
        "yyyy-MM-dd",
        "yyyy年MM月dd日",
        "MMdd",
        "MM/dd",
        "MM-dd",
        "MM月dd日",
        "yyyyMMdd HH:mm:ss",
        "yyyy/MM/dd HH:mm:ss",
        "yyyy-MM-dd HH:mm:ss",
        "yyyy年MM月dd日 HH时mm分ss秒",
        "yyyy年第ww周",
        "yyyy年MM月第WW周",
        "yyyy年第QQ季度",
        "yyyy年QQ季度"
      )
      if (formatList.contains(format)){
        format
          .replace("yyyy", s"""$YEAR""")
          .replace("MM", s"""$month""")
          .replace("M", s"""$MONTH""")
          .replace("dd", s"""$dayOfMonth""")
          .replace("d", s"""$DAY_OF_MONTH""")
          .replace("HH", s"""$hourOfDay""")
          .replace("mm", s"""$minute""")
          .replace("ss", s"""$second""")
          .replace("ww", s"""$weekOfYear""")
          .replace("WW", s"""$weekOfMonth""")
          .replace("QQ", s"""$quarter""")

      } else {
        throw new RuntimeException(
          s"""
             |时间格式错误，当前只支持以下23种格式：
             |
             |yyyy,
             |QQ,
             |MM,
             |dd,
             |HH,
             |mm,
             |ss,
             |yyyyMM,
             |yyyy/MM,
             |yyyy-MM,
             |yyyy年MM月,
             |yyyyMMdd,
             |yyyy/MM/dd,
             |yyyy-MM-dd,
             |yyyy年MM月dd日,
             |MMdd,
             |MM/dd,
             |MM-dd,
             |MM月dd日,
             |yyyyMMdd HH:mm:ss,
             |yyyy/MM/dd HH:mm:ss,
             |yyyy-MM-dd HH:mm:ss,
             |yyyy年MM月dd日 HH时mm分ss秒,
             |yyyy年第ww周,
             |yyyy年MM月第WW周,
             |yyyy年第QQ季度,
             |yyyy年QQ季度
             |
             |您输入的时间格式字符串为：$format
             |""".stripMargin)
      }
    }
  }
  /**
    * 作者：王志豪
    * 方法功能：获取calendar对象
    * 处理逻辑：判断date是否为空，如果为空则返回null，否则返回date对应的calendar
    * @return date对应的calendar
    */
  private def getCalendar(): Calendar = {
    if(date == null){
      null
    } else {
      val cal = Calendar.getInstance()
      cal.setFirstDayOfWeek(Calendar.MONDAY)
      cal.setTime(date)
      cal
    }
  }
  /**
    * 作者：王志豪
    * 方法功能：获取date对应的季度
    * 处理逻辑：1月到3月为1季度，3月到6月为2季度，7月到9月为3季度，10月到12月为4季度。不在此范围则抛出异常
    * @return 返回date对应的季度
    */
  private def getQuarter(): Int = {

    MONTH match {
      case 1 => 1
      case 2 => 1
      case 3 => 1
      case 4 => 2
      case 5 => 2
      case 6 => 2
      case 7 => 3
      case 8 => 3
      case 9 => 3
      case 10 => 4
      case 11 => 4
      case 12 => 4
      case _ => throw new RuntimeException("月份超出正常值外")
    }
  }
  private def toDate(): Date = {
    if(datetime == null){
      new Date()
    } else if ("null".equals(datetime)) {
      null
    } else {
      new SimpleDateFormat(parseFormat(datetime)).parse(datetime)
    }
  }
  /**
    * 作者：王志豪
    * 方法功能：解析时间格式
    * 处理逻辑：1、判断字符串是否为空，如果为空则返回null，不为空则舍去毫秒
    *          2、正则匹配时间字符串的格式，并返回格式。
    * @param dateString 时间字符串
    * @return 时间字符串datestring所对应的时间格式。
    */
  private def parseFormat(dateString: String): String = {
    val time = if(dateString != null) dateString.split("\\.")(0) else null
    if(time == null){
      null
    } else if(time.matches("^\\d{6}$")){
      "yyyyMM"
    } else if(time.matches("^\\d{4}/\\d{2}$")){
      "yyyy/MM"
    } else if(time.matches("^\\d{4}-\\d{2}$")){
      "yyyy-MM"
    } else if(time.matches("^\\d{4}年\\d{2}月$")){
      "yyyy年MM月"
    } else if(time.matches("^\\d{8}$")){
      "yyyyMMdd"
    } else if(time.matches("^\\d{4}/\\d{2}/\\d{2}$")){
      "yyyy/MM/dd"
    } else if(time.matches("^\\d{4}/\\d{1}/\\d{1}$")){
      "yyyy/MM/dd"
    } else if(time.matches("^\\d{4}/\\d{1}/\\d{2}$")){
      "yyyy/MM/dd"
    } else if(time.matches("^\\d{4}/\\d{2}/\\d{1}$")){
      "yyyy/MM/dd"
    } else if(time.matches("^\\d{4}-\\d{2}-\\d{2}$")){
      "yyyy-MM-dd"
    } else if(time.matches("^\\d{4}年\\d{2}月\\d{2}日$")){
      "yyyy年MM月dd日"
    } else if(time.matches("^\\d{8}\\s\\d{2}:\\d{2}:\\d{2}$")){
      "yyyyMMdd HH:mm:ss"
    } else if(time.matches("^\\d{4}/\\d{2}/\\d{2}\\s\\d{2}:\\d{2}:\\d{2}$")){
      "yyyy/MM/dd HH:mm:ss"
    } else if(time.matches("^\\d{4}/\\d{1}/\\d{2}\\s\\d{2}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    } else if(time.matches("^\\d{4}/\\d{1}/\\d{1}\\s\\d{2}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    } else if(time.matches("^\\d{4}/\\d{1}/\\d{1}\\s\\d{1}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    }else if(time.matches("^\\d{4}/\\d{2}/\\d{2}\\s\\d{1}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    }else if(time.matches("^\\d{4}/\\d{1}/\\d{2}\\s\\d{1}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    }else if(time.matches("^\\d{4}/\\d{2}/\\d{1}\\s\\d{2}:\\d{2}:\\d{2}$")) {
      "yyyy/MM/dd HH:mm:ss"
    }else if(time.matches("^\\d{4}-\\d{2}-\\d{2}\\s\\d{2}:\\d{2}:\\d{2}$")){
      "yyyy-MM-dd HH:mm:ss"
    } else {
      throw new RuntimeException(
        s"""
           |时间格式错误，当前只支持以下11种格式：
           |yyyyMM，
           |yyyy-MM，
           |yyyy/MM，
           |yyyy年MM月，
           |yyyyMMdd，
           |yyyy-MM-dd，
           |yyyy/MM/dd，
           |yyyy年MM月dd日，
           |yyyyMMdd HH:mm:ss，
           |yyyy-MM-dd HH:mm:ss，
           |yyyy/MM/dd HH:mm:ss。
           |需要解析的时间字符串为：$dateString
           |""".stripMargin)
    }
  }
}
